# Replication Package
This replication package contains all the data and scripts necessary to replicate the results obtained in our evaluation. 

## Code
The folder `code` contains the implementation of our approach, GELID. The sub-folder contains a `README.md` file with the details on how to run each step.

## Data and Raw Results
The folder `data-and-results` contains all the data used to evaluate GELID and the raw results of the evaluations. Specifically, this folder contains a sub-folder for each RQ.

### Training set
The folder `training_set` contains:

- The evaluation of the keywords generated for the automatic segmentation of the video and the final keyword list used.
- The file containing the links extracted through the model trained by Lin et al. to detect only the videos containing the bugs (`all_link_training.csv`).
- The training set file containing the categorised video segments used for the evaluation of RQ2 (`training_set.csv`) .

### Component Evaluation Dataset
The folder `component_evaluation_dataset` contains:

- The ranking file of the 100 most popular games on Steam at the time of the evaluation (`top_100 steam_selection.csv`)

- Test set files for the three videogames selected for RQs evaluation. Specifically:
    - `test_set_conan_gameplay.csv`
    - `test_set_dayz_gameplay.csv`
    - `test_set_new_world_gameplay.csv`

- Test set filtred with only informative video segments fot each three video games selected. Specifically:
    - `informative_conan_gameplay.csv`
    - `informative_dayz_gameplay.csv`
    - `informative_new_world_gameplay.csv`

### RQ1
Data for evaluating the Video Segmentation component of GELID. It includes:

- A sub-folder for each videogames in the test set for the eveluation of the three thresholds taken into account t={0,5,10}. Specifically, there are a sub-folders for each thresholds t.

- The results of manual evaluation to assess the atomicity and interpretability of the segments obtained. Specifically:
    - `atomicity_cohens_kappa.xlsx`
    - `atomicity_threshold_t.xlsx`
    - `nterpretability_cohens_kappa.xlsx`
    - `interpretability_threshold_t.xlsx`

- A sub-folder (`analysis`) which contains files for the evaluation of results conducted through manual analysis on interpretability and atomicity.


### RQ2
Data for evaluating the Segment Categorization component of GELID. It includes:

- A sub-folder that contain the dataset of video segmentation used to obtain the training .arff files obtained from the extraction of the only textual features 
  of the three models used (bag of word, word2vec and doc2vec).

- A sub-folder that contain the dataset of video segmentation used to obtain the training .arff files obtained from the extraction of the video features: Specifically, it contains:
    - A sub-folder that contain the dataset of video segmentation used to obtain the training .arff files obtained from the extraction of the only video features.
    - A sub-folder that contain the dataset of video segmentation used to obtain the training .arff files obtained from the extraction of the textual and video features. 
      Specifically with the textual features best model.

- A sub-folder (`weka_analysis`) which contains files for the evaluation of results conducted on traing set (both multi-class and binary) and on test set (both multi-class and binary).

### RQ3
Data for evaluating the Context-Based Segment Grouping component of GELID. It includes:

- A sub-folder of results obtained for each videogames selected in Components validation dateset. Specifically each sub-folder contains:
    - All game frames extracted for context-based evaluation.
    - The file containing the video features (based on the HSV and SSIM technique) used for clustering.
    - Four sub-folder one for each cluster technique evaluated (DBSCAN and OPTICS) and for each image similarity technique. Specifically they contain:
        - The results of the evalutaion by MoJoFM, and the file that able to replicate the evaluation.



### RQ4
Data for evaluating the Issue-Based Segment Grouping component of GELID. It includes:

- A sub-folder of results obtained for each videogames selected in Components validation dateset. Specifically each sub-folder contains:
    - The file containing the video features (based on video feature with HSV technique and texual features with word2vec) used for clustering.
    - Three sub-folder one for each cluster technique evaluated (DBSCAN, OPTICS and MeanShift). Specifically they contain:
        - The results of the evalutaion by MoJoFM, and the file that able to replicate the evaluation.
