import os
import nltk
import spacy
import pandas as pd
from pytube import YouTube
from chdir import cwd
import ffmpeg
import cv2
import cv2 as cv
import numpy as np
from sys import maxsize
from PIL import Image
import glob
import natsort
import csv
import pandas as pd
import statistics
from skimage.transform import resize
from gensim.models import Word2Vec, KeyedVectors
from spacy.tokens import token

model_path=os.path.abspath("GoogleNews-vectors-negative300.bin")
model = KeyedVectors.load_word2vec_format(model_path, binary=True)



SAVE_PATH = "video"

def youtubeVideo(path):
  
  list_name_feature=[]
  for i in range(313):
    f=f"f_{i}"
    list_name_feature.append(f)


  header=list_name_feature
  
  with open("feature_cluster_issue.csv", "w", newline='') as cluster_file:
    cluster_writer = csv.writer(cluster_file)
    cluster_writer.writerow(header)

    nlp = spacy.load('en_core_web_sm')
    stopwords = spacy.lang.en.stop_words.STOP_WORDS

    with open(path, 'r') as f: # open in readonly mode
        video_list= pd.read_csv(f)

        for idx,row in video_list.iterrows():
            subtitle=row['caption']
            try:
                sub=subtitle.lower()
            except:
                print("no-lower-caption")    
            doc = nlp(sub)

            # Generate the tokens
            tokens = [token.text for token in doc]
            

            # Generate lemmatized tokens
            lemmas = [token.lemma_ for token in doc]

            # Remove stopwords and non-alphabetic tokens
            a_lemmas = [lemma for lemma in lemmas if lemma.isalpha() and lemma in model and lemma not in stopwords]
            print(a_lemmas)

            vectors = [model.get_vector(lemma) for lemma in a_lemmas]
            if (len(vectors) == 0):
                continue

            result = []
            for i in range(0, len(vectors[0])):
                sum = 0.0
                for j in range(0, len(vectors)):
                    sum += vectors[j][i]
                average = sum / len(vectors)
                result.append(average)
            
            print(len(result))

            features_list = list(result)
            features_w2v=','.join(str(e) for e in features_list)

            url=row['url_video']
            label=row['labeled']

            path_video = f"segment-{idx}-{label}"
            if not os.path.exists(path_video):
                os.mkdir(path_video)
            
            try: 
                my_video = YouTube(url) 
            except: 
                print("Connection Error")
            
            print("********************Download video*************************")
            #get all the stream resolution for the

            #Download video
            with cwd(path_video):
                try:
                    for stream in my_video.streams:
                        print(stream)

            #set stream resolution
                    my_video = my_video.streams.get_highest_resolution()
                    video=my_video.download(None,"video.mp4")
                    print("path video ", path_video )
                except:
                    with open("info.txt", "w") as f:
                        f.write(url) 

            
                    
            start_segment=str(row['start-segment(s)'])
            end_segment=str(row['end-segment(s)'])

            
            in_file = ffmpeg.input(video)

            try:
                (
                    in_file.trim(start=start_segment, end=end_segment).setpts('PTS-STARTPTS')
                    .output(f"{path_video}/segment.mp4")
                    .run()
                )
            except:
                print("segment no-analysed")

            segment_file=f"{path_video}/segment.mp4"
            print("Start frame extraction")
            os.mkdir(f"{path_video}/frames")
            
            video_capture = cv2.VideoCapture(segment_file)
            success,image = video_capture.read()
            count = 0
            while success:
                cv2.imwrite(f"{path_video}/frames/%d.jpg" % count, image)  
                success,image = video_capture.read()
                print('Read a new frame: ', success)
                count += 1

            #****************************#
            image_list = list(glob.glob(os.path.join(f"{path_video}/frames",'*.jpg')))
            order_image_list=natsort.natsorted(image_list)
            print(order_image_list)
            num_image= len(image_list)
            print("\nImages:", num_image) 

            image_id1=0
            image_id2=1

            total_matrix= np.zeros((180,320))


            for image in range(num_image-1):
                image1 = order_image_list[image_id1]
                image2 = order_image_list[image_id2]
                
                first= cv.imread(image1)
                second= cv.imread(image2)

                # Convert images to grayscale
                first_gray = cv.cvtColor(first, cv.COLOR_BGR2GRAY)
                second_gray = cv.cvtColor(second, cv.COLOR_BGR2GRAY)

                #Resize image
                first_resize=resize(first_gray,(180,320))
                second_resize=resize(second_gray,(180,320))

                array_frame1 = np.array(first_resize)
                array_frame2 = np.array(second_resize)    

                check_frames = array_frame1 == array_frame2

                for i in range(0,len(check_frames)):
                    for j in range(len(check_frames[i])):
                        if check_frames[i][j] == False:
                            total_matrix[i][j] = total_matrix[i][j]+1
                    
                image_id1+=1
                image_id2+=1


        
            vector_total_matrix= total_matrix.flatten()
            
            vector_total_matrix.sort()
            print('List in Ascending Order: ', vector_total_matrix)
            vector_len=len(vector_total_matrix)
            max_value_hm = max(vector_total_matrix/num_image)
            print('Maximum value:', max_value_hm)
            min_value_hm = min(vector_total_matrix/num_image)
            print('Min value:', min_value_hm)
            
            median_hm = statistics.median(vector_total_matrix/num_image)
            print('Median', median_hm)
            mean_hm = statistics.mean(vector_total_matrix/num_image)
            print('Mean', mean_hm)
            
            first_quantile_hm=np.quantile(vector_total_matrix/num_image, 0.25)
            print('1Q', first_quantile_hm)
            third_quantile_hm=np.quantile(vector_total_matrix/num_image, 0.75)
            print('3Q', third_quantile_hm)


            #****************************#
            image_list = list(glob.glob(os.path.join(f"{path_video}/frames",'*.jpg')))
            order_image_list=natsort.natsorted(image_list)

            num_image= len(image_list)
            print("\nImages:", num_image)
            count=num_image/2

            image_id_1=0
            image_id_2=1
            id_frame_pair=-1

            header=["id_frame_pair","frame1", "frame2", "correlation"]

            with open(f"{path_video}/segment-results.csv", 'w', newline='') as csv_file:
                writer = csv.writer(csv_file)
                writer.writerow(header)
                for image in range(num_image-1):
                    image_1 = order_image_list[image_id_1]
                    image_2 = order_image_list[image_id_2]


                    first_image= cv.imread(image_1)
                    second_image= cv.imread(image_2)

                    hsv_image_1 = cv.cvtColor(first_image, cv.COLOR_BGR2HSV)
                    hsv_image_2 = cv.cvtColor(second_image, cv.COLOR_BGR2HSV)

                    h_bins = 50
                    s_bins = 60
                    histSize = [h_bins, s_bins]
                    h_ranges = [0, 180]
                    s_ranges = [0, 256]
                    ranges = h_ranges + s_ranges
                    channels = [0, 1]

                    hist_image_1 = cv.calcHist([hsv_image_1], channels, None, histSize, ranges, accumulate=False)
                    cv.normalize(hist_image_1, hist_image_1, alpha=0, beta=1, norm_type=cv.NORM_MINMAX)

                    hist_image_2 = cv.calcHist([hsv_image_2], channels, None, histSize, ranges, accumulate=False)
                    cv.normalize(hist_image_2, hist_image_2, alpha=0, beta=1, norm_type=cv.NORM_MINMAX)


                    compare_method = cv.HISTCMP_CORREL

                    correlation = cv.compareHist(hist_image_1, hist_image_2, compare_method)

                    frame_1= order_image_list[image_id_1]
                    frame_2=order_image_list[image_id_2]

                    frame_pair1=frame_1
                    frame_pair2=frame_2

                    image_id_1+=1
                    image_id_2+=1
                    id_frame_pair+=1

                    writer.writerow([id_frame_pair, frame_pair1, frame_pair2, correlation])


            csv_file.close

            similarity = pd.read_csv(f"{path_video}/segment-results.csv")
            similarity_score=similarity.correlation

        
            abs_similarity_score=abs(similarity_score)
            max_value_similarity = max(abs_similarity_score)
            print('Maximum value:', max_value_similarity)
            min_value_similarity = min(abs_similarity_score)
            print('Min value:', min_value_similarity)
            
            median_similarity = statistics.median(abs_similarity_score)
            print('Median', median_similarity)
            mean_similarity = statistics.mean(abs_similarity_score)
            print('Mean', mean_similarity)

            first_quantile_similarity=np.quantile(abs_similarity_score, 0.25)
            print("1Q: ", first_quantile_similarity)
            third_quantile_similarity=np.quantile(abs_similarity_score, 0.75)
            print("3Q: ", third_quantile_similarity)
                
            print(features_w2v)

            cluster_writer.writerow([features_w2v,max_value_hm,min_value_hm,median_hm,mean_hm,first_quantile_hm,third_quantile_hm,max_value_similarity, min_value_similarity, median_similarity,mean_similarity,mean_similarity,first_quantile_similarity,third_quantile_similarity])
        
  cluster_file.close
