# GELID

The steps are provided in isolation for allowing future researchers to replicate the results.

## 1. Video Segmentation

Go to the folder `1-video-segmentation` and run `main.py`, specifying the path to the file with the links to the YouTube videos (use `input_link_file.csv`), one of the three proposed t-thresholds for segmentation (0,5,10) and a custom name for the result folder (it will be in the format `results-{x}`, where x is the specified name). The list of videos can contain either the video URL (one for each line).
The script will create a folder `results-{x}` with a sub-folder for each video `segment-{t}-{labeled}` and it will place in it the video (mp4 format), json file that contain the downloaded caption and a sub-folder `segment` that contain n sub-folder based on the segment extracted. Each sub-folder `segment-{seconds}-{keyword}` contains the video segment (mp4 format) in in which the keyword was found.

## 2. Video Slicer

Go to the folder `2-segment-categorization`.
- Go to the folder `feature_textual_extraction` for the extraction of only textual features and run in isolation each file:
    - `features_extraction_bag_of_words.py`, for the extraction of textual features based on bag of words model.
    - `features_extraction_doc2vec.py`, for the extraction of textual features based on doc2vec model.
    - `features_extraction_word2vec.py`, for the extraction of textual features based on word2vec model.
The output of each script is an .arff file containing features extracted according to the model used.

- Go to the folder `features_image_extraction\features_frame_extraction` for the extraction of only video features and run `main.py`, specifying the path to the file with the links to the YouTube 
  videos (use `input_link_file.csv`). The script will create a folder `results-{x}` with a sub-folder for each video `segment-{t}-{labeled}`  and will insert the entire video and the specific segment (mp4 format), 
  a `segment-results.csv` that contain the evaluation of the features image for a single segment and a sub-folder `frames` that contain all frames extracted from the segment of video.
  The final output is an .arff file containing features extracted.

- Go to the folder `features_image_extraction\features_textual_frame_extraction` for the extraction of textual and video features and run `main.py`, specifying the path to the file with the links to the YouTube 
  videos (use `input_link_file.csv`). The script will create a folder `results-{x}` with a sub-folder for each video `segment-{t}-{labeled}`  and will insert the entire video and the specific segment (mp4 format), 
  a `segment-results.csv` that contain the evaluation of the features image for a single segment and a sub-folder `frames` that contain all frames extracted from the segment of video.
  The output is an .arff file containing features extracted from the image analysis and texual features with the best texual model obtained (word2vec).

## 3. Context-Based Segment Grouping

Go to the folder `3-context-based-segment-grouping` more specifically:
- Go to the folder `clustering_scene` for the extraction of only video features and run `main.py`, specifying the path to the file with the links to the YouTube 
  videos (use `input_link_file.csv`). The script will create a folder `results-{x}` with a sub-folder for each video `segment-{t}-{labeled}`  and will insert the entire video and the specific segment (mp4 format), 
  and a sub-folder `keyframes` that contain the keyframes extracted from the specific segment of video.
  The final output is a number of representative frames corresponding to the number of extracted segments and a file `final-segment-similarity.csv` that contains the features extracted

- Run the flie `DBSCAN.ipynb`, specifying the path to the file with the data to be analysed (use `file_input.csv`) and obtain as output a representation of the clustering classes identified with 
  the non-parametri cclustering technique DBSCAN.

- Run the flie `OPTICS.ipynb`, specifying the path to the file with the data to be analysed (use `file_input.csv`) and obtain as output a representation of the clustering classes identified with 
  the non-parametric clustering technique OPTICS.

## 4. Issue-Based Segment-Clustering

Go to the folder `4-issue-based-segment-clustering` more specifically:
- Go to the folder `clustering_issues` for the extraction of only video features and run `main.py`, specifying the path to the file with the links to the YouTube 
  videos (use `input_link_file.csv`). The script will create a folder `results-{x}` with a sub-folder for each video `segment-{t}-{labeled}` and will insert the entire video and the specific segment (mp4 format), 
  a `segment-results.csv` that contain the evaluation of the features image for a single segment and a sub-folder `frames` that contain all frames extracted from the segment of video.
  The final output is a labeld video segment and a file `feature_cluster_isseus.csv` that contains the features extracted.

- Run the flie `DBSCAN.ipynb`, specifying the path to the file with the data to be analysed (use `file_input.csv`) and obtain as output a representation of the clustering classes identified with 
  the non-parametric clustering technique DBSCAN.

- Run the flie `MeanShift.ipynb`, specifying the path to the file with the data to be analysed (use `file_input.csv`) and obtain as output a representation of the clustering classes identified with 
  the non-parametric clustering technique DBSCAN.

- Run the flie `OPTICS.ipynb`, specifying the path to the file with the data to be analysed (use `file_input.csv`) and obtain as output a representation of the clustering classes identified with 
  the non-parametric clustering technique DBSCAN.