from ffmpy import FFmpeg
import ffmpy
import ffmpeg
import json
import os 
import spacy
import numpy as np
import pandas as pd
from chdir import cwd

def videoTrimTrashold(file, keyword, threshold):
    
    nlp = spacy.load('en_core_web_sm')

    os.mkdir("segments")
    print("Threshold to trim video") 

    print("threshold: ", threshold)

    with open(file) as f:
        # returns JSON object as 
        # a dictionary
        data = json.load(f)
        
        last_element=data[-1]
        end_video=int(last_element['start'])+int(last_element['duration'])
        # Iterating through the json
        # list
        for element in data:
            caption= str(element['text'])
            start_caption= int(element['start'])
            duration_caption= int(element['duration'])
            end_caption= start_caption + duration_caption
            words= nlp(caption.lower())


            words_caption= [token.text for token in words]
            

            for w in words_caption:
                for k in keyword:
                    if w == k:
                        time_start= start_caption-int(threshold)
                        time_end= end_caption + int(threshold)

                        if time_end > end_video:
                            time_end=end_video

                        in_file = ffmpeg.input('video.mp4')  #####CHECKTOPASSVIDEO###
                        segment_folder = f"segments/s-{time_start}-{k}"
                        try:
                            os.mkdir(segment_folder)
                            (
                                in_file.trim(start=time_start, end=time_end).setpts('PTS-STARTPTS')
                                .output(f"{segment_folder}/segment.mp4")
                                .run()
                            )
                        except:
                            print("segment analysed")
                    
                    else:
                        print("Non-matching keyword")


                
