# Library
library(effsize)

data <- read.csv("interpretability_threshold_t.csv")


#--------------------RQ1interpretability--------------------#


#----------Wilcoxon Test-----------#
wilcox.test(data$interpretability.t0, data$interpretability.t5, paired = TRUE, alternative = "two.sided")

wilcox.test(data$interpretability.t0, data$interpretability.t10, paired = TRUE, alternative = "two.sided")

wilcox.test(data$interpretability.t5, data$interpretability.t10, paired = TRUE, alternative = "two.sided")


#------Benjamini and Hochberg procedure------#
p.adjust(c(2.2e-16, 2.2e-16, 2.2e-16), method="BH")

#----------Effesize-----------#

cliff.delta(data$interpretability.t0, data$interpretability.t5)
cliff.delta(data$interpretability.t0, data$interpretability.t10)
cliff.delta(data$interpretability.t5, data$interpretability.t10)

#----------BoxPlot-----------#
boxplot(data$interpretability.t0, data$interpretability.t5, data$interpretability.t10, names = c("t=0", "t=5", "t=10"), col = c("deepskyblue" , "coral2", "aquamarine3"), ylab="interpretability", ylim= c(0,5.5))



#--------------------RQ1atomicity--------------------#

data <- read.csv("atomicity_threshold_t.csv")


#----------Wilcoxon Test-----------#
wilcox.test(data$atomicity.t0, data$atomicity.t5, paired = TRUE, alternative = "two.sided")

wilcox.test(data$atomicity.t0, data$atomicity.t10, paired = TRUE, alternative = "two.sided")

wilcox.test(data$atomicity.t5, data$atomicity.t10, paired = TRUE, alternative = "two.sided")


#------Benjamini and Hochberg procedure------#
p.adjust(c(1.314e-13, 2.2e-16,4.791e-16), method="BH")
#----------Effesize-----------#

cliff.delta(data$atomicity.t0, data$atomicity.t5)
cliff.delta(data$atomicity.t0, data$atomicity.t10)
cliff.delta(data$atomicity.t5, data$atomicity.t10)

#----------BoxPlot-----------#
boxplot(data$atomicity.t0, data$atomicity.t5, data$atomicity.t10, names = c("t=0", "t=5", "t=10"), col = c("deepskyblue" , "coral2", "aquamarine3"), ylab="atomicity", ylim= c(0,5.5))


