library(irr)
library(psych)

# Interpretability

# Read in the data from a CSV file
data <- read.csv("interpretability_cohen’s_kappa.csv")

# Assign the columns for the two annotators' responses
annotator_interpretability1 <- data$interpretability_eval1
annotator_interpretability2 <- data$interpretability_eval2

# Calculate Cohen's kappa coefficient
kappa <- cohen.kappa(x=cbind (rater1= annotator_interpretability1, rater2= annotator_interpretability2))

# Print the results
kappa

# Atomicity
library(psych)

# Read in the data from a CSV file
data <- read.csv("atomicity_cohen’s_kappa.csv")

# Assign the columns for the two annotators' responses
atomicity_annotator1 <- data$atomicity_eval1
atomicity_annotator2 <- data$atomicity_eval2

# Calculate Cohen's kappa coefficient
kappa <- cohen.kappa(x=cbind (rater1= atomicity_annotator1, rater2= atomicity_annotator2))

# Print the results
kappa
